# Interface IModuleAttribute

All Superinterfaces:
  `IClassFileAttribute`

public interface IModuleAttribute extends IClassFileAttribute
Description of a module's attributes as described in the JVM specifications.

Since:
  3.14
Restriction:
  This interface is not intended to be implemented by clients.

## Method Summary

Modifier and Type
Method
Description
`int`
`getExportsCount()`
Answer back the exports count.
`IPackageVisibilityInfo[]`
`getExportsInfo()`
Answer back the array of exports infos of the .class file, an empty array if none.
`int`
`getModuleFlags()`
Answer back the module flags.
`char[]`
`getModuleName()`
Answer back the module name.
`int`
`getModuleNameIndex()`
Answer back the module name index.
`int`
`getModuleVersionIndex()`
Answer back the module version index.
`char[]`
`getModuleVersionValue()`
Answer back the module version string.
`int`
`getOpensCount()`
Answer back the opens count.
`IPackageVisibilityInfo[]`
`getOpensInfo()`
Answer back the array of opens infos of the .class file, an empty array if none.
`int`
`getProvidesCount()`
Answer back the provides count.
`IProvidesInfo[]`
`getProvidesInfo()`
Answer back the array of provides infos of the .class file, an empty array if none.
`int`
`getRequiresCount()`
Answer back the requires count.
`IRequiresInfo[]`
`getRequiresInfo()`
Answer back the array of requires infos of the .class file, an empty array if none.
`char[][]`
`getUsesClassNames()`
Answer back the array of uses class names of the .class file, an empty array if none.
`int`
`getUsesCount()`
Answer back the uses count.
`int[]`
`getUsesIndices()`
Answer back the array of uses indices of the .class file, an empty array if none.

### Methods inherited from interface IClassFileAttribute

`getAttributeLength, getAttributeName, getAttributeNameIndex`

## Method Details

### getModuleNameIndex

int getModuleNameIndex()
Answer back the module name index.

Returns:
  the module name index

### getModuleName

char[] getModuleName()
Answer back the module name.

Returns:
  the module name

### getModuleFlags

int getModuleFlags()
Answer back the module flags.

Returns:
  the module flags

### getModuleVersionIndex

int getModuleVersionIndex()
Answer back the module version index.

Returns:
  the module version index

### getModuleVersionValue

char[] getModuleVersionValue()
Answer back the module version string.

Returns:
  the module version string

### getRequiresCount

int getRequiresCount()
Answer back the requires count.

Returns:
  the requires counts

### getRequiresInfo

IRequiresInfo[] getRequiresInfo()
Answer back the array of requires infos of the .class file, an empty array if none.

Returns:
  the array of requires infos of the .class file, an empty array if none

### getExportsCount

int getExportsCount()
Answer back the exports count.

Returns:
  the exports counts

### getExportsInfo

IPackageVisibilityInfo[] getExportsInfo()
Answer back the array of exports infos of the .class file, an empty array if none.

Returns:
  the array of exports infos of the .class file, an empty array if none

### getOpensCount

int getOpensCount()
Answer back the opens count.

Returns:
  the opens counts

### getOpensInfo

IPackageVisibilityInfo[] getOpensInfo()
Answer back the array of opens infos of the .class file, an empty array if none.

Returns:
  the array of opens infos of the .class file, an empty array if none

### getUsesCount

int getUsesCount()
Answer back the uses count.

Returns:
  the uses counts

### getUsesIndices

int[] getUsesIndices()
Answer back the array of uses indices of the .class file, an empty array if none.

Returns:
  the array of uses indices of the .class file, an empty array if none

### getUsesClassNames

char[][] getUsesClassNames()
Answer back the array of uses class names of the .class file, an empty array if none.

Returns:
  the array of uses class names of the .class file, an empty array if none

### getProvidesCount

int getProvidesCount()
Answer back the provides count.

Returns:
  the provides counts

### getProvidesInfo

IProvidesInfo[] getProvidesInfo()
Answer back the array of provides infos of the .class file, an empty array if none.

Returns:
  the array of provides infos of the .class file, an empty array if none